(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/Semant.sml,v
   Comment: Semantic analysis for Absyn.sml models
   Release: scope-0-16_final

     Copyright (C) 2001-2002 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTES:

   WARNING: the meaning of the file has changed since rev. 1.5. It sed to be
   a typechecker for vsr (hse?) files imported from Jorn. I do not intend to
   maintain vsr typechecking. Instead some rudimentary typechecking for high
   level abstract syntax is placed here.

   THIS MODULE IS NOT FULLY IMPLEMENTED !

   Currently it tests following consistency conditions:

   1. root node has no parents (#parent root = NONE)

   Note that some tests are redundant (succesful result is implied by
   algorithm how values are built). They should be then considered as sanity
   checks of implementation correctness.

   TODO: 
   
   1. default node of orstate is always one of its children
   2. all non root state have SOME parent and they actually children of this
      parent
   3. Check if initial variable environment is consistent with variable
      typing
   4. The type of binary neg operand should be integer
   5. The type of boolean neg should be integer or real 
      (results in int type)
   6. Thy type of arithmetic neg should be int or real 
      (results in given type)
   
   Semant.sml,v 1.12 2002/11/04 21:55:52 wasowski Exp
*)


structure Semant :> Semant = struct
	
  open Absyn;

  fun checkh (h :hierarchy) :bool =
	let val ANDState root = gettree h
	in #parent root = NONE end

  fun checksys { name, hierarchy, vartypes, evtypes, evgroups, 
                 otypes, trans, denv, venv, cenv } = checkh hierarchy
  
  fun typecheck (m :model) :bool = List.all checksys m
	
end



