#!/usr/bin/perl -w 
#
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/compile.pl,v
# Comment: A shortcut for code genereting and compiling a model (debug mode) 
# Release: scope-0-16_final
#
#    Copyright (C) 2001-2003 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Currently code generates and compiles in debug mode but may be changed 
# in feature. 
#
# Usage:
#
# compile path_to_model [codgen [output_dir [preopts]]]
#
# defualt output dir is sandbox/.
#
# WARNING: no error control
#
# compile.pl,v 1.11 2003/07/26 20:59:11 wasowski Exp
# 

use File::Basename;
use test::src::ScopeTest;

if (! $ARGV[0]) { 
	print "\ncompile.pl  path_to_model [codgen [output_dir [preopts]]]\n\n"; 
	exit;
}

$file=$ARGV[0];

if ($ARGV[1]) { $codgen=$ARGV[1]; }
else { $codgen = "C1"; }

if ($codgen ne "C1" && $codgen ne "CF") {
	print "Error: unknown code generator.\n";
	exit 1;
}

if ($ARGV[2]) { $outdir = $ARGV[2]."/"; }
else { $outdir = "test/sandbox/"; }

if ($ARGV[3]) { $preopts = $ARGV[3]; }
else { $preopts = ""; }

if ( (system "$ScopeTest::scope $preopts --queuelen=20 --debug --outdir=$outdir --externhdr=extern.h " .
	     "-o system -c$codgen " .
	     "-o extern -cCstubs -o main.c -cCdrv $file") == 0
	&& (system ("cc -pedantic -g -I $ScopeTest::scopedir -I $outdir/ --ansi " . 
		    "$outdir/main.c $outdir/extern.c $outdir/system.c " . 
		    "-o $outdir/system" )) == 0)  
     { exit 0; } 
else { exit 1; }


