#!/usr/bin/perl -w 
#
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/compilemin.pl,v
# Comment: A shortcut for code genereting and compiling a model 
# Release: scope-0-16_final
#
#    Copyright (C) 2001-2004 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Currently code generates and compiles in minimal release mode but may be changed 
# in feature. 
#
# defualt output dir is test/sandbox/.
#
# WARNING: no error control
#
# compilemin.pl,v 1.14 2004/05/05 21:29:05 wasowski Exp

use File::Basename;
use test::src::ScopeTest;

if (! $ARGV[0]) { 
	print "\ncompilemin.pl path_to_model [codgen [output_dir [lcc|gcc|h8|atmega16 [preopts]]]]\n\n"; 
	exit;
}


$file=$ARGV[0];
$fbase = fileparse($file,qr/\.[^.]*/);

if ($ARGV[1]) { $codgen=$ARGV[1]; }
else { $codgen = "C1"; }

if ($codgen ne "C1" && $codgen ne "CF") {
	print "Error: unknown code generator.\n";
	exit 1;
}
if ($ARGV[2]) { $outdir = $ARGV[2]."/"; }
else { $outdir = "test/sandbox/"; }


# select the compiler needed

if ($ARGV[3] &&  $ARGV[3] eq "lcc") { 

    $compiler = "lcc -A -A"; 
    $strip    = "strip";


} else { if ($ARGV[3] && $ARGV[3] eq "h8") { 

    $compiler = "h8300-hms-gcc"; 
    $strip    = "h8300-hms-strip";
    #print "WARNING:NOSTRIP\n";
    #$strip   = "touch";

} else { if ($ARGV[3] && $ARGV[3] eq "atmega16") {

    $compiler = "avr-gcc -mmcu=atmega16 -mtiny-stack";
    $strip    = "avr-strip";
    # This script needs to be rewritten with proper option handling (getopt)
    # then we can provide real support for more flexibility
    print "WARNING:NOSTRIP\n";
    $strip    = "touch";

} else {
    $compiler="gcc"; 
    $strip="strip";

} } }



if ($ARGV[4]) { $preopts = $ARGV[4]; }
else { $preopts = ""; }


if ( (system "rm -Rf $outdir/*") == 0
	&& (system "$ScopeTest::scope $preopts -V 4 --outdir=$outdir --release -c$codgen $file -cCstubs -cCdrv") == 0
	&& (system ("$compiler -Os --ansi --std=c99 -pedantic " .
			"-I$ScopeTest::scopedir -DNDEBUG " . 
			"-fomit-frame-pointer -foptimize-sibling-calls " .
			"-Xlinker --relax " .
			"-I$outdir/ $outdir/*.c -o $outdir/$fbase")) == 0
        && (system "$strip $outdir/$fbase") == 0
	&& (system "ls -l $outdir/$fbase") == 0 )
     { exit 0; } 
else { exit 1; }


