#!/usr/bin/perl -w 
# File : /home/cvs/cvsroot/projects/visualstate/scope/test/src/compilespeed.pl,v
# Comment: A shortcut for code genereting and compiling a model
#          in smoke(speed/release) mode 
# Release: scope-0-16_final
#
#    Copyright (C) 2002 Andrzej Wasowski
#    
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#    
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
# Usage: # compilespeed path_to_model [output_dir]
# defualt output dir is sandbox/.
#
# compilespeed.pl,v 1.6 2003/07/28 14:33:28 wasowski Exp

use File::Basename;
use test::src::ScopeTest;

if (! $ARGV[0]) { 
	print "\ncompilespeed.pl  path_to_model [codgen [output_dir [preopts]]]\n\n"; 
	exit;
}

$file=$ARGV[0];
$fbase = fileparse($file,qr/\.[^.]*/);
$preopts = "";

if ($ARGV[1]) { $codgen=$ARGV[1]; }
else { $codgen = "C1"; }

if ($codgen ne "C1" && $codgen ne "CF") {
	print "Error: unknown code generator.\n";
	exit 1;
}


if ($ARGV[2]) { $outdir = $ARGV[2]."/"; }
else { $outdir = "test/sandbox/"; }

if ($ARGV[3] && $ARGV[3] eq "lcc") { $compiler="lcc -A -A"; } 
else { $compiler="gcc -Os --ansi -pedantic"; }

if ($ARGV[4]) { $preopts = $ARGV[4]; }
else { $preopts = ""; }



if ( (system "rm -Rf $outdir/*") == 0
	&& (system "$ScopeTest::scope $preopts --queuelen=20 --outdir=$outdir --release --smoke -c$codgen $file -cCstubs -cCdrv") == 0
	&& (system ("$compiler -DNDEBUG  -I$ScopeTest::scopedir -I$outdir/ $outdir/*.c -o $outdir/$fbase")) == 0
        && (system "strip $outdir/$fbase") == 0 )
     { exit 0; } 
else { exit 1; }


