(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/test/src/tparserl-file.sml,v
   Comment: test of RL parser with file as input interface
   Release: scope-0-16_final

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


   tparserl-file.sml,v 1.2 2003/07/08 15:45:06 wasowski Exp
*)

app load ["ListPair","Parsercomb","parserl","Test"];

open Test ParseRL Parsercomb Types;

(* testcases *)

val testcases = [("test/parser/test1.rl",SOME 
	 [Inter("name_1", [], [NeverE "e", NeverE "e2", NeverE "e1"]),
          Inter("name_n", [], [ConstrV(IntT, "name", ValI 2)]),
          Inter("r", [], [ConstrV(FloatT, "name", ValR 2.0)]),
          Inter("A", ["B", "C", "D"], []),
          Inter("restriction_name", ["name_1", "name_n"],
                [NeverE "eventname1", NeverE "eventname2",
                 ConstrV(IntT, "name", ValI 2), ConstrV(IntT, "name3", ValI 1),
                 Dead(IntT, "name"), Dead(IntT, "name2"),
                 ConstrF(IntT, "f", ValI 4), ConstrF(IntT, "g", ValI 5),
                 Pure(IntT, "f")]),
          IBinding("restriction_name_1", "systemname_1"),
          IBinding("restriction_name_2", "systemname_2"),
	  IBinding("restriction_name_3", "sys1"),
	  IBinding("restriction_name_3", "sys2"),
	  IBinding("restriction_name_3", "sys3"),
	  Inter("name", [], [NeverE "event1", Dead(IntT, "k")]),
          IBinding("name", "restricted_system"), 
	  IBinding("name", "sy3") ]) ];

(* initialize *)

val testname = "parserl-file";
val _ = Test.init testname;

fun testparser (fname,res) :bool =
	parseFile fname  = res 

val res = map (fn (f,r) => test testparser (f,r) f) testcases;

val _ = Test.finalise testname res;

