(* 
   File   : /home/cvs/cvsroot/projects/visualstate/scope/util/env-test.sml,v 
   Comment: Test script for env-fn 
   Release: scope-0-16_final

     Copyright (C) 2003 Andrzej Wasowski
     
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   NOTE: run in interactive environment

	mosml -P full env-test.sml

   Only contains one trivial test for fromList/toList and filter.
   
   env-test.sml,v 1.1 2003/02/15 18:51:07 wasowski Exp
*)

load  "Intmap";
use "env-sig.sml";
use "env-fn.sml";

structure RealEnv = EnvFn( type key = int val toInt = fn x => x );

val nats = [(1,1.0),(2,2.0),(3,3.0),(4,4.0)];

fun isodd n = n mod 2 = 1

val nats_env = RealEnv.fromList nats
val nats1 = RealEnv.toList nats_env;

val odd_env = RealEnv.filter isodd nats_env
val odds = RealEnv.toList odd_env

val filter_results = [nats=nats1, odds = [(1,1.0),(3,3.0)]];

